#include <stdlib.h>
#include <stdio.h>
#include "popp_thread.h"

int t = 2;
int *array;
const int length = 100000;
int count;
const int iters = 10000; /* artificially multiply work */

struct padded_int
{
  int value;
  char padding[60];
} private_count[MaxThreads];

mutex m = INIT_MUTEX;

void count3s_thread(int id)
{
  int length_per_thread = length / t;
  int start = id * length_per_thread;
  int i, j;

  for (j = 0; j < iters; j++) {
    for (i = start; i < start + length_per_thread; i++) {
      if (array[i] == 3) {
        private_count[id].value++;
      }
    }
  }

  mutex_lock(m);
  count += private_count[id].value;
  mutex_unlock(m);
}

int count3s()
{
  int i;

  count = 0;

  for (i = 0; i < t; i++)
    thread_create(count3s_thread, i);

  join_threads();

  return count;
}

/*****************************************/

static void make_array()
{
  int i;
  array = (int *)malloc(length * sizeof(int));
  for (i = 0; i < length; i++)
    array[i] = i % 10;
}

int main(int argc, char **argv) 
{
  make_array();

  printf("%d\n", count3s());

  return 0;
}
